/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */
#line 19 "parser.y" /* yacc.c:339  */


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

static int parser_error(parser_ctx_t *,const char*);

static void parse_complete(parser_ctx_t*,BOOL);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t);
static statement_t *new_call_statement(parser_ctx_t*,BOOL,member_expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,dim_decl_t*);
static statement_t *new_while_statement(parser_ctx_t*,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,const_decl_t*);
static statement_t *new_select_statement(parser_ctx_t*,expression_t*,case_clausule_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,BOOL,dim_list_t*);
static dim_list_t *new_dim(parser_ctx_t*,unsigned,dim_list_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,expression_t*,statement_t*,case_clausule_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_dim_prop(parser_ctx_t*,class_decl_t*,dim_decl_t*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT


#line 134 "parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.tab.h".  */
#ifndef YY_PARSER_PARSER_TAB_H_INCLUDED
# define YY_PARSER_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    tEOF = 258,
    tNL = 259,
    tEMPTYBRACKETS = 260,
    tLTEQ = 261,
    tGTEQ = 262,
    tNEQ = 263,
    tSTOP = 264,
    tME = 265,
    tREM = 266,
    tTRUE = 267,
    tFALSE = 268,
    tNOT = 269,
    tAND = 270,
    tOR = 271,
    tXOR = 272,
    tEQV = 273,
    tIMP = 274,
    tIS = 275,
    tMOD = 276,
    tCALL = 277,
    tDIM = 278,
    tSUB = 279,
    tFUNCTION = 280,
    tGET = 281,
    tLET = 282,
    tCONST = 283,
    tIF = 284,
    tELSE = 285,
    tELSEIF = 286,
    tEND = 287,
    tTHEN = 288,
    tEXIT = 289,
    tWHILE = 290,
    tWEND = 291,
    tDO = 292,
    tLOOP = 293,
    tUNTIL = 294,
    tFOR = 295,
    tTO = 296,
    tEACH = 297,
    tIN = 298,
    tSELECT = 299,
    tCASE = 300,
    tBYREF = 301,
    tBYVAL = 302,
    tOPTION = 303,
    tNOTHING = 304,
    tEMPTY = 305,
    tNULL = 306,
    tCLASS = 307,
    tSET = 308,
    tNEW = 309,
    tPUBLIC = 310,
    tPRIVATE = 311,
    tNEXT = 312,
    tON = 313,
    tRESUME = 314,
    tGOTO = 315,
    tIdentifier = 316,
    tString = 317,
    tDEFAULT = 318,
    tERROR = 319,
    tEXPLICIT = 320,
    tPROPERTY = 321,
    tSTEP = 322,
    tLong = 323,
    tShort = 324,
    tDouble = 325
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 86 "parser.y" /* yacc.c:355  */

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    dim_list_t *dim_list;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    case_clausule_t *case_clausule;
    unsigned uint;
    LONG lng;
    BOOL boolean;
    double dbl;

#line 264 "parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int parser_parse (parser_ctx_t *ctx);

#endif /* !YY_PARSER_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 280 "parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1094

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  87
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  61
/* YYNRULES -- Number of rules.  */
#define YYNRULES  223
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  397

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   325

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    81,     2,
      76,    77,    84,    82,    75,    78,    74,    85,    73,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    71,     2,
      80,    72,    79,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    83,     2,    86,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   147,   147,   150,   151,   153,   155,   156,   159,   160,
     163,   164,   167,   170,   171,   172,   173,   174,   177,   178,
     179,   181,   182,   183,   185,   188,   191,   192,   193,   194,
     195,   196,   197,   198,   200,   201,   202,   203,   204,   206,
     208,   212,   213,   216,   217,   220,   221,   222,   225,   226,
     229,   230,   233,   236,   237,   240,   241,   244,   245,   248,
     250,   251,   254,   256,   259,   260,   263,   264,   267,   271,
     272,   275,   276,   277,   281,   282,   285,   286,   289,   290,
     291,   293,   295,   298,   299,   302,   303,   306,   307,   310,
     311,   314,   315,   318,   319,   322,   323,   326,   327,   328,
     329,   330,   331,   332,   333,   336,   337,   340,   341,   342,
     345,   346,   349,   350,   354,   355,   357,   361,   362,   365,
     366,   367,   368,   371,   372,   375,   376,   377,   378,   379,
     380,   381,   384,   385,   386,   387,   390,   391,   392,   395,
     396,   399,   402,   403,   405,   407,   408,   411,   413,   415,
     419,   421,   425,   426,   429,   430,   431,   434,   435,   438,
     439,   442,   443,   444,   448,   449,   450,   451,   452,   453,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     510,   511,   512,   513
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tEOF", "tNL", "tEMPTYBRACKETS", "tLTEQ",
  "tGTEQ", "tNEQ", "tSTOP", "tME", "tREM", "tTRUE", "tFALSE", "tNOT",
  "tAND", "tOR", "tXOR", "tEQV", "tIMP", "tIS", "tMOD", "tCALL", "tDIM",
  "tSUB", "tFUNCTION", "tGET", "tLET", "tCONST", "tIF", "tELSE", "tELSEIF",
  "tEND", "tTHEN", "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP", "tUNTIL",
  "tFOR", "tTO", "tEACH", "tIN", "tSELECT", "tCASE", "tBYREF", "tBYVAL",
  "tOPTION", "tNOTHING", "tEMPTY", "tNULL", "tCLASS", "tSET", "tNEW",
  "tPUBLIC", "tPRIVATE", "tNEXT", "tON", "tRESUME", "tGOTO", "tIdentifier",
  "tString", "tDEFAULT", "tERROR", "tEXPLICIT", "tPROPERTY", "tSTEP",
  "tLong", "tShort", "tDouble", "':'", "'='", "'0'", "'.'", "','", "'('",
  "')'", "'-'", "'>'", "'<'", "'&'", "'+'", "'\\\\'", "'*'", "'/'", "'^'",
  "$accept", "Program", "OptionExplicit_opt", "SourceElements",
  "StatementsNl_opt", "StatementsNl", "StatementNl", "Statement",
  "SimpleStatement", "MemberExpression", "DimDeclList", "DimDecl",
  "DimList", "ConstDeclList", "ConstDecl", "ConstExpression", "DoType",
  "Step_opt", "IfStatement", "EndIf_opt", "ElseIfs_opt", "ElseIfs",
  "ElseIf", "Else_opt", "CaseClausules", "Arguments_opt",
  "ArgumentList_opt", "ArgumentList", "EmptyBrackets_opt",
  "ExpressionList", "Expression", "EqvExpression", "XorExpression",
  "OrExpression", "AndExpression", "NotExpression", "EqualityExpression",
  "ConcatExpression", "AdditiveExpression", "ModExpression",
  "IntdivExpression", "MultiplicativeExpression", "ExpExpression",
  "UnaryExpression", "CallExpression", "LiteralExpression",
  "NumericLiteralExpression", "IntegerValue", "PrimaryExpression",
  "ClassDeclaration", "ClassBody", "PropertyDecl", "FunctionDecl",
  "Storage_opt", "Storage", "ArgumentsDecl_opt", "ArgumentDeclList",
  "ArgumentDecl", "Identifier", "DotIdentifier", "StSep", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    58,    61,    48,    46,    44,    40,    41,    45,    62,
      60,    38,    43,    92,    42,    47,    94
};
# endif

#define YYPACT_NINF -214

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-214)))

#define YYTABLE_NINF -153

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -28,   -39,    66,  -214,    12,  -214,   389,    12,    12,  -214,
    -214,  -214,  -214,    55,    -7,    -7,   618,    87,   618,     7,
     200,     6,    -7,    55,    41,  -214,    65,  -214,  -214,  -214,
    -214,  -214,  -214,   712,   618,  -214,    71,    10,   422,  -214,
      62,  -214,  -214,  -214,   119,  -214,  -214,  -214,  -214,     9,
    -214,    35,    20,  -214,    40,    68,  -214,  -214,   618,  -214,
    -214,  -214,    -7,  -214,  -214,  -214,  -214,  -214,   650,     9,
      28,   129,   132,   135,   144,  -214,    15,    95,   -29,   161,
     116,   101,   111,  -214,    62,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,    29,  -214,  -214,   618,   762,    -7,   130,   618,
      12,     9,  -214,   103,  -214,    21,  -214,   712,  -214,   521,
     521,   152,  -214,  -214,    51,    -1,  1027,    -7,    -7,   521,
     145,  -214,    -7,  -214,     4,    -7,   171,  -214,  -214,  -214,
    -214,   618,   492,   618,   618,   618,   618,   650,   650,   650,
     650,   650,   650,   650,   650,   650,   650,   650,   650,   650,
     650,   650,   812,    29,   168,  -214,   712,   182,   618,    29,
     134,   154,   170,   157,  -214,  -214,  -214,   155,    11,   618,
     521,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
    -214,  -214,    23,    23,  -214,  -214,  -214,  -214,   158,   159,
    -214,   143,  -214,  -214,   129,   712,   100,   132,   135,   144,
    -214,    95,    95,    95,    95,    95,    95,    95,   -29,   161,
     161,   116,   101,   111,   111,  -214,   207,   762,    78,  -214,
     618,    22,   191,    -7,   213,    12,    12,    43,   185,   618,
    -214,  -214,  -214,   228,  -214,   114,  -214,    12,    12,  -214,
       4,  -214,   217,   962,   221,  -214,  -214,   214,   618,    29,
     618,   588,   222,    12,   203,   134,   134,    18,    12,   228,
      -7,    -7,   179,   184,   252,   862,   862,  -214,   618,   230,
    -214,   217,   236,  -214,  -214,   228,   912,    24,    12,    12,
      33,   218,   134,    12,  -214,  -214,   211,   212,   215,   134,
     252,   252,  -214,   114,  -214,   242,   243,    36,   274,   249,
    -214,  -214,   234,   618,    12,   962,   712,   618,  -214,  -214,
    -214,    23,   229,   231,  -214,  -214,  -214,  -214,   269,   272,
     300,   862,   279,  -214,   228,   912,  -214,   191,  -214,    12,
     114,   114,  -214,  -214,   712,  -214,  -214,   254,  -214,   862,
     232,   237,  -214,  -214,   281,    12,    12,   253,   862,   862,
    -214,   288,   289,   256,   259,  -214,  -214
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     5,     0,     1,   152,   220,   221,     4,
       2,    34,   140,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   155,   156,     0,   164,   165,   166,
     167,   168,   169,    13,     0,     6,     0,    15,    81,    22,
       0,   123,     7,    27,     0,   153,    41,   222,   223,    81,
      21,    43,    45,    37,    50,     0,   125,   126,     0,   131,
     129,   130,     0,   127,   134,   132,   135,   133,     0,    81,
       0,    85,    87,    89,    91,    93,    95,    97,   105,   107,
     110,   112,   114,   117,   120,   119,   128,    32,    30,    28,
      29,    31,     0,    55,    56,     0,   152,     0,     0,     0,
       0,    81,   154,     0,    14,     0,    12,    17,    82,     0,
       0,   124,    18,    77,    76,    78,     0,     0,     0,     0,
      19,    74,     0,    47,     0,     0,     0,    96,   121,   122,
     124,     0,   152,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,     0,     0,     9,    10,     0,     0,     0,
     152,   124,     0,     0,   139,    16,    80,     0,     0,     0,
       0,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     170,    42,    81,    81,    44,   138,   136,   137,     0,    48,
      51,     0,    52,    53,    86,     8,    62,    88,    90,    92,
      94,   103,   102,    99,   104,    98,   100,   101,   106,   109,
     108,   111,   113,   115,   116,   118,     0,   152,    26,    11,
       0,     0,    71,     0,     0,     0,     0,     0,   153,     0,
      35,    36,    75,    20,    79,     0,   157,     0,     0,    46,
       0,    54,    64,   152,     0,    60,    23,     0,     0,     0,
       0,     0,     0,     0,     0,   152,   152,     0,     0,    33,
       0,     0,     0,   159,    81,   152,   152,    49,     0,    69,
      65,    66,    62,    63,    24,    25,   152,    57,     0,     0,
      83,     0,   152,     0,   146,   143,     0,     0,     0,   152,
      81,    81,   158,     0,   161,     0,     0,     0,     0,     0,
      67,    61,     0,     0,     0,   152,     8,     0,    40,   145,
     141,    81,     0,     0,   144,   162,   163,   160,     0,     0,
       0,   152,     0,    39,    58,   152,    72,    71,    84,     0,
       0,     0,   150,   151,     8,    70,    59,     0,    73,   152,
       0,     0,    68,    38,     0,     0,     0,     0,   152,   152,
     147,     0,     0,     0,     0,   148,   149
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -214,  -214,  -214,  -214,  -151,  -152,   320,   -25,  -214,    -6,
     205,    67,    49,   206,  -214,  -214,    74,  -214,  -214,    26,
    -214,    32,  -214,  -214,   -34,     1,  -214,   -33,   -35,   -12,
      46,   216,   219,   210,   223,   -43,  -214,   147,   201,    63,
     199,   208,    42,   -62,    -4,   225,   117,  -214,  -214,  -214,
    -128,  -214,  -126,  -124,  -122,  -213,    27,  -153,    17,  -214,
       5
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     6,   154,   155,   156,    36,    37,    69,
      50,    51,   228,    53,    54,   232,    95,   344,    39,   285,
     309,   310,   311,   339,   292,   111,   112,   167,   121,   319,
     115,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,   229,    41,    42,
     264,   265,    43,    44,    45,   277,   302,   303,    46,   221,
       9
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      38,   256,    40,   114,   259,   113,   129,    49,   104,    40,
     278,     7,    47,    48,   108,   127,     7,   101,   131,    40,
       1,   137,   138,   139,    96,   123,     4,    38,   108,    40,
     131,    52,    55,     7,   266,   140,   267,    98,   268,   100,
     131,   131,    93,   131,   326,   327,    94,   131,   131,   145,
     120,    99,   131,   146,    27,   131,    28,    29,    30,    31,
      32,   132,    70,   290,    92,    12,     5,   117,   118,   360,
     130,   328,   225,   226,   170,   106,   166,   227,     8,   128,
     105,   107,   165,     8,   282,   119,   170,   141,   164,   255,
      38,   343,    40,   240,   142,   143,   124,   152,   164,   275,
       8,    38,   161,    40,   102,   160,   287,   236,   347,   297,
     122,    87,    88,    93,   157,   125,    27,    94,    28,    29,
      30,    31,    32,   -74,    89,   -74,    38,    90,    40,   103,
     283,    34,   284,   220,   222,   223,   116,   274,   369,    52,
     126,   153,    55,   117,   118,   159,    38,   133,    40,   134,
      38,   135,    40,    91,   335,   336,   168,   263,   257,   136,
     300,   301,   162,   163,   262,   342,  -142,   324,   325,   266,
     266,   267,   267,   268,   268,    27,   144,    28,    29,    30,
      31,    32,   147,    56,    57,   149,   150,   276,   276,    24,
      25,   253,   254,   366,   349,   367,   266,   151,   267,   148,
     268,   354,   158,   266,   261,   267,   258,   268,   249,   250,
     375,    64,    65,    66,   377,   273,    67,   380,   381,  -124,
      59,    60,    61,   382,   169,   260,   269,   270,   384,    38,
     271,    40,   272,    63,   280,   279,   291,   391,   392,    64,
      65,    66,    97,   286,    67,   294,   298,   131,   308,   231,
     313,    38,   314,    40,   321,   323,   332,   108,   312,   333,
     338,    27,   348,    28,    29,    30,    31,    32,   284,   334,
     295,   296,   351,   352,   358,   359,   353,    38,   361,    40,
      52,   362,   305,   306,   241,   242,   243,   244,   245,   246,
     247,   363,   304,   372,   316,   355,   356,   373,   322,    38,
      38,    40,    40,   329,   374,   370,   289,   371,   376,   385,
      38,   383,    40,   387,   386,   299,   276,   330,   331,   390,
     393,   394,   395,   345,   346,   396,    35,   224,   350,   307,
     293,   230,   288,   378,   315,   368,   317,   320,   341,    38,
      38,    40,    40,   340,   238,   248,   251,   234,   281,   365,
     304,   233,   237,     0,   337,    38,   252,    40,   239,    38,
     357,    40,     0,     0,     0,     0,     0,     0,    38,     0,
      40,     0,     0,    38,   379,    40,     0,     0,     0,     0,
       0,     0,    38,    38,    40,    40,     0,   304,   304,   364,
     388,   389,    10,   320,     0,     0,     0,     0,    11,    12,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,    14,     0,     0,     0,     0,    15,    16,     0,
       0,     0,     0,    17,    18,     0,    19,   108,     0,    20,
       0,     0,    12,    21,    56,    57,    58,     0,     0,     0,
       0,    22,    23,     0,    24,    25,     0,    26,     0,     0,
      27,     0,    28,    29,    30,    31,    32,     0,     0,     0,
      33,     0,     0,     0,     0,    34,     0,     0,     0,     0,
       0,    59,    60,    61,     0,     0,    62,     0,     0,     0,
       0,     0,     0,    27,    63,    28,    29,    30,    31,    32,
      64,    65,    66,     0,     0,    67,   235,   109,   110,     0,
      68,    11,    12,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,    14,     0,     0,     0,     0,
      15,    16,     0,     0,     0,     0,    17,    18,     0,    19,
       0,    12,    20,    56,    57,    58,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,     0,     0,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,     0,     0,     0,     0,    34,     0,
      59,    60,    61,     0,     0,    62,     0,     0,     0,     0,
       0,     0,    27,    63,    28,    29,    30,    31,    32,    64,
      65,    66,     0,     0,    67,     0,   109,    34,    12,    68,
      56,    57,    58,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   318,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      56,    57,    58,     0,     0,     0,     0,    59,    60,    61,
       0,     0,    62,     0,     0,     0,     0,     0,     0,    27,
      63,    28,    29,    30,    31,    32,    64,    65,    66,     0,
      12,    67,    56,    57,    34,     0,    68,    59,    60,    61,
       0,     0,    62,     0,     0,     0,     0,     0,     0,    27,
      63,    28,    29,    30,    31,    32,    64,    65,    66,     0,
       0,    67,     0,     0,    34,     0,    68,     0,     0,    59,
      60,    61,     0,     0,    62,     0,     0,     0,     0,     0,
       0,    27,    63,    28,    29,    30,    31,    32,    64,    65,
      66,    11,    12,    67,     0,     0,    34,     0,    68,     0,
       0,     0,     0,     0,    13,    14,  -152,  -152,     0,     0,
      15,    16,     0,     0,     0,     0,    17,    18,     0,    19,
       0,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,    11,    12,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,    13,    14,     0,     0,    34,     0,
      15,    16,     0,     0,     0,     0,    17,    18,     0,    19,
      -8,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,    11,    12,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,    13,    14,     0,     0,    34,     0,
      15,    16,     0,     0,     0,     0,    17,    18,    -8,    19,
       0,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,    11,    12,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,    13,    14,     0,     0,    34,     0,
      15,    16,     0,     0,    -8,     0,    17,    18,     0,    19,
       0,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,    11,    12,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,    13,    14,     0,     0,    34,     0,
      15,    16,     0,     0,     0,     0,    17,    18,     0,    19,
       0,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,    -8,
      26,    11,    12,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,    13,    14,     0,     0,    34,     0,
      15,    16,     0,     0,     0,     0,    17,    18,     0,    19,
       0,     0,    20,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,    24,    25,     0,
      26,     0,     0,    27,     0,    28,    29,    30,    31,    32,
       0,     0,     0,    33,     0,     0,     0,     0,    34,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    27,     0,
      28,    29,    30,    31,    32
};

static const yytype_int16 yycheck[] =
{
       6,   152,     6,    38,   156,    38,    68,    13,    33,    13,
     223,     4,     7,     8,     5,    58,     4,    23,    19,    23,
      48,     6,     7,     8,    19,     5,    65,    33,     5,    33,
      19,    14,    15,     4,   160,    20,   160,    20,   160,    22,
      19,    19,    35,    19,    26,    27,    39,    19,    19,    78,
      49,    45,    19,    82,    61,    19,    63,    64,    65,    66,
      67,    33,    16,    41,    18,    10,     0,    24,    25,    33,
      69,    53,    68,    69,    75,     4,   109,    73,    71,    62,
      34,    71,   107,    71,   235,    76,    75,    72,    77,   151,
      96,    67,    96,   136,    79,    80,    76,    92,    77,    76,
      71,   107,   101,   107,    63,   100,   257,   132,    75,    66,
      75,    24,    25,    35,    97,    75,    61,    39,    63,    64,
      65,    66,    67,    72,    37,    74,   132,    40,   132,    64,
      30,    76,    32,   116,   117,   118,    74,   170,   351,   122,
      72,    95,   125,    24,    25,    99,   152,    18,   152,    17,
     156,    16,   156,    66,   305,   306,   110,    23,   153,    15,
      46,    47,    59,    60,   159,   316,    32,   295,   296,   295,
     296,   295,   296,   295,   296,    61,    81,    63,    64,    65,
      66,    67,    21,    12,    13,    84,    85,   222,   223,    55,
      56,   149,   150,   345,   322,   346,   322,    86,   322,    83,
     322,   329,    72,   329,   158,   329,    38,   329,   145,   146,
     361,    68,    69,    70,   365,   169,    73,   370,   371,    74,
      49,    50,    51,   374,    72,    43,    72,    57,   379,   235,
      73,   235,    77,    62,    75,    77,    45,   388,   389,    68,
      69,    70,    42,    36,    73,    32,    61,    19,    31,    78,
      29,   257,    38,   257,    32,    52,    77,     5,   283,    75,
      30,    61,    44,    63,    64,    65,    66,    67,    32,   304,
     265,   266,    61,    61,    32,    32,    61,   283,     4,   283,
     263,    32,   277,   278,   137,   138,   139,   140,   141,   142,
     143,    57,   275,    24,   289,   330,   331,    25,   293,   305,
     306,   305,   306,   298,     4,    76,   260,    76,    29,    77,
     316,    57,   316,    32,    77,   269,   351,   300,   301,    66,
      32,    32,    66,   318,   319,    66,     6,   122,   323,   280,
     263,   125,   258,   367,   288,   347,   290,   291,   312,   345,
     346,   345,   346,   311,   134,   144,   147,   131,   231,   344,
     333,   126,   133,    -1,   308,   361,   148,   361,   135,   365,
     333,   365,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,
     374,    -1,    -1,   379,   369,   379,    -1,    -1,    -1,    -1,
      -1,    -1,   388,   389,   388,   389,    -1,   370,   371,   343,
     385,   386,     3,   347,    -1,    -1,    -1,    -1,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,    28,    29,    -1,
      -1,    -1,    -1,    34,    35,    -1,    37,     5,    -1,    40,
      -1,    -1,    10,    44,    12,    13,    14,    -1,    -1,    -1,
      -1,    52,    53,    -1,    55,    56,    -1,    58,    -1,    -1,
      61,    -1,    63,    64,    65,    66,    67,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    73,     4,    75,    76,    -1,
      78,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    37,
      -1,    10,    40,    12,    13,    14,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,    -1,    -1,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    -1,
      49,    50,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    73,    -1,    75,    76,    10,    78,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    49,    50,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      10,    73,    12,    13,    76,    -1,    78,    49,    50,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    -1,    76,    -1,    78,    -1,    -1,    49,
      50,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,     9,    10,    73,    -1,    -1,    76,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    -1,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    37,
      -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,     9,    10,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    22,    23,    -1,    -1,    76,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,     9,    10,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    22,    23,    -1,    -1,    76,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    36,    37,
      -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,     9,    10,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    22,    23,    -1,    -1,    76,    -1,
      28,    29,    -1,    -1,    32,    -1,    34,    35,    -1,    37,
      -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,     9,    10,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    22,    23,    -1,    -1,    76,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    37,
      -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    57,
      58,     9,    10,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    22,    23,    -1,    -1,    76,    -1,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    37,
      -1,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      58,    -1,    -1,    61,    -1,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    48,    88,    89,    65,     0,    90,     4,    71,   147,
       3,     9,    10,    22,    23,    28,    29,    34,    35,    37,
      40,    44,    52,    53,    55,    56,    58,    61,    63,    64,
      65,    66,    67,    71,    76,    93,    94,    95,    96,   105,
     131,   135,   136,   139,   140,   141,   145,   147,   147,    96,
      97,    98,   145,   100,   101,   145,    12,    13,    14,    49,
      50,    51,    54,    62,    68,    69,    70,    73,    78,    96,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,    24,    25,    37,
      40,    66,   117,    35,    39,   103,   147,    42,   145,    45,
     145,    96,    63,    64,    94,   117,     4,    71,     5,    75,
      76,   112,   113,   114,   115,   117,    74,    24,    25,    76,
     112,   115,    75,     5,    76,    75,    72,   122,   145,   130,
     112,    19,    33,    18,    17,    16,    15,     6,     7,     8,
      20,    72,    79,    80,    81,    78,    82,    21,    83,    84,
      85,    86,   147,   117,    91,    92,    93,   145,    72,   117,
     147,   112,    59,    60,    77,    94,   114,   114,   117,    72,
      75,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     145,   146,   145,   145,    97,    68,    69,    73,    99,   134,
     100,    78,   102,   132,   118,     4,    94,   119,   120,   121,
     122,   124,   124,   124,   124,   124,   124,   124,   125,   126,
     126,   127,   128,   129,   129,   130,    91,   147,    38,    92,
      43,   117,   147,    23,   137,   138,   139,   140,   141,    72,
      57,    73,    77,   117,   114,    76,   115,   142,   142,    77,
      75,   133,    91,    30,    32,   106,    36,    91,   103,   117,
      41,    45,   111,    98,    32,   147,   147,    66,    61,   117,
      46,    47,   143,   144,   145,   147,   147,    99,    31,   107,
     108,   109,    94,    29,    38,   117,   147,   117,    30,   116,
     117,    32,   147,    52,   137,   137,    26,    27,    53,   147,
     145,   145,    77,    75,   115,    91,    91,   117,    30,   110,
     108,   106,    91,    67,   104,   147,   147,    75,    44,   137,
     147,    61,    61,    61,   137,   115,   115,   143,    32,    32,
      33,     4,    32,    57,   117,   147,    92,    91,   116,   142,
      76,    76,    24,    25,     4,    91,    29,    91,   111,   147,
     144,   144,    91,    57,    91,    77,    77,    32,   147,   147,
      66,    91,    91,    32,    32,    66,    66
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    87,    88,    89,    89,    90,    90,    90,    91,    91,
      92,    92,    93,    94,    94,    94,    94,    94,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    96,    96,    97,    97,    98,    98,    98,    99,    99,
     100,   100,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   107,   107,   108,   108,   109,   110,
     110,   111,   111,   111,   112,   112,   113,   113,   114,   114,
     114,   115,   115,   116,   116,   117,   117,   118,   118,   119,
     119,   120,   120,   121,   121,   122,   122,   123,   123,   123,
     123,   123,   123,   123,   123,   124,   124,   125,   125,   125,
     126,   126,   127,   127,   128,   128,   128,   129,   129,   130,
     130,   130,   130,   131,   131,   132,   132,   132,   132,   132,
     132,   132,   133,   133,   133,   133,   134,   134,   134,   135,
     135,   136,   137,   137,   137,   137,   137,   138,   138,   138,
     139,   139,   140,   140,   141,   141,   141,   142,   142,   143,
     143,   144,   144,   144,   145,   145,   145,   145,   145,   145,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     147,   147,   147,   147
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     3,     0,     2,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     3,     2,     2,     3,
       4,     2,     1,     5,     6,     6,     4,     1,     2,     2,
       2,     2,     2,     5,     1,     4,     4,     2,    10,     8,
       7,     1,     3,     1,     3,     1,     4,     2,     1,     3,
       1,     3,     3,     1,     2,     1,     1,     0,     2,     9,
       5,     7,     0,     2,     0,     1,     1,     2,     5,     0,
       3,     0,     4,     5,     1,     3,     1,     1,     1,     3,
       2,     0,     1,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     2,     1,     3,     3,
       3,     3,     3,     3,     3,     1,     3,     1,     3,     3,
       1,     3,     1,     3,     1,     3,     3,     1,     3,     1,
       1,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     7,     0,     3,     4,     4,     3,     9,    11,    11,
       8,     8,     0,     1,     2,     1,     1,     1,     3,     1,
       3,     2,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (ctx, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, ctx);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parser_ctx_t *ctx)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 147 "parser.y" /* yacc.c:1648  */
    { parse_complete(ctx, (yyvsp[-2].boolean)); }
#line 1805 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 3:
#line 150 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = FALSE; }
#line 1811 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 4:
#line 151 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = TRUE; }
#line 1817 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 6:
#line 155 "parser.y" /* yacc.c:1648  */
    { source_add_statement(ctx, (yyvsp[0].statement)); }
#line 1823 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 7:
#line 156 "parser.y" /* yacc.c:1648  */
    { source_add_class(ctx, (yyvsp[0].class_decl)); }
#line 1829 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 8:
#line 159 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 1835 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 9:
#line 160 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1841 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 10:
#line 163 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1847 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 11:
#line 164 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1853 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 12:
#line 167 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1859 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 13:
#line 170 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 1865 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 14:
#line 171 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1871 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 15:
#line 172 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1877 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 16:
#line 173 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].statement)->next = (yyvsp[0].statement); (yyval.statement) = (yyvsp[-2].statement); }
#line 1883 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 17:
#line 174 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1889 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 18:
#line 177 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.statement) = new_call_statement(ctx, FALSE, (yyvsp[-1].member)); CHECK_ERROR; }
#line 1895 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 19:
#line 178 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.statement) = new_call_statement(ctx, TRUE, (yyvsp[-1].member)); CHECK_ERROR; }
#line 1901 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 20:
#line 180 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].member)->args = (yyvsp[-2].expression); (yyval.statement) = new_assign_statement(ctx, (yyvsp[-3].member), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1907 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 21:
#line 181 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_dim_statement(ctx, (yyvsp[0].dim_decl)); CHECK_ERROR; }
#line 1913 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 22:
#line 182 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1919 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 23:
#line 184 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, STAT_WHILE, (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1925 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 24:
#line 186 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-4].boolean) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[-3].expression), (yyvsp[-1].statement));
                                              CHECK_ERROR; }
#line 1932 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 25:
#line 189 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-1].boolean) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[0].expression), (yyvsp[-3].statement));
                                              CHECK_ERROR; }
#line 1939 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 26:
#line 191 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_while_statement(ctx, STAT_DOWHILE, NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1945 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 27:
#line 192 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_function_statement(ctx, (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 1951 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 28:
#line 193 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0); CHECK_ERROR; }
#line 1957 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 29:
#line 194 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0); CHECK_ERROR; }
#line 1963 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 30:
#line 195 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0); CHECK_ERROR; }
#line 1969 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 31:
#line 196 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0); CHECK_ERROR; }
#line 1975 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 32:
#line 197 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0); CHECK_ERROR; }
#line 1981 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 33:
#line 199 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].member)->args = (yyvsp[-2].expression); (yyval.statement) = new_set_statement(ctx, (yyvsp[-3].member), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1987 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 34:
#line 200 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_statement(ctx, STAT_STOP, 0); CHECK_ERROR; }
#line 1993 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 35:
#line 201 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_onerror_statement(ctx, TRUE); CHECK_ERROR; }
#line 1999 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 36:
#line 202 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_onerror_statement(ctx, FALSE); CHECK_ERROR; }
#line 2005 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 37:
#line 203 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_const_statement(ctx, (yyvsp[0].const_decl)); CHECK_ERROR; }
#line 2011 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 38:
#line 205 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_forto_statement(ctx, (yyvsp[-8].string), (yyvsp[-6].expression), (yyvsp[-4].expression), (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2017 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 39:
#line 207 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_foreach_statement(ctx, (yyvsp[-5].string), (yyvsp[-3].expression), (yyvsp[-1].statement)); }
#line 2023 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 40:
#line 209 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_select_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].case_clausule)); }
#line 2029 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 41:
#line 212 "parser.y" /* yacc.c:1648  */
    { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[0].string)); CHECK_ERROR; }
#line 2035 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 42:
#line 213 "parser.y" /* yacc.c:1648  */
    { (yyval.member) = new_member_expression(ctx, (yyvsp[-2].expression), (yyvsp[0].string)); CHECK_ERROR; }
#line 2041 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 43:
#line 216 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = (yyvsp[0].dim_decl); }
#line 2047 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 44:
#line 217 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].dim_decl)->next = (yyvsp[0].dim_decl); (yyval.dim_decl) = (yyvsp[-2].dim_decl); }
#line 2053 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 45:
#line 220 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR; }
#line 2059 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 46:
#line 221 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-3].string), TRUE, (yyvsp[-1].dim_list)); CHECK_ERROR; }
#line 2065 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 47:
#line 222 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-1].string), TRUE, NULL); CHECK_ERROR; }
#line 2071 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 48:
#line 225 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[0].uint), NULL); }
#line 2077 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 49:
#line 226 "parser.y" /* yacc.c:1648  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[-2].uint), (yyvsp[0].dim_list)); }
#line 2083 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 50:
#line 229 "parser.y" /* yacc.c:1648  */
    { (yyval.const_decl) = (yyvsp[0].const_decl); }
#line 2089 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 51:
#line 230 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].const_decl)->next = (yyvsp[0].const_decl); (yyval.const_decl) = (yyvsp[-2].const_decl); }
#line 2095 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 52:
#line 233 "parser.y" /* yacc.c:1648  */
    { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[-2].string), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2101 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 53:
#line 236 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2107 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 54:
#line 237 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2113 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 55:
#line 240 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = TRUE; }
#line 2119 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 56:
#line 241 "parser.y" /* yacc.c:1648  */
    { (yyval.boolean) = FALSE; }
#line 2125 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 57:
#line 244 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL;}
#line 2131 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 58:
#line 245 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2137 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 59:
#line 249 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-7].expression), (yyvsp[-4].statement), (yyvsp[-3].elseif), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2143 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 60:
#line 250 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), NULL, NULL); CHECK_ERROR; }
#line 2149 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 61:
#line 252 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-5].expression), (yyvsp[-3].statement), NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2155 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 64:
#line 259 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = NULL; }
#line 2161 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 65:
#line 260 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2167 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 66:
#line 263 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2173 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 67:
#line 264 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].elseif)->next = (yyvsp[0].elseif); (yyval.elseif) = (yyvsp[-1].elseif); }
#line 2179 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 68:
#line 268 "parser.y" /* yacc.c:1648  */
    { (yyval.elseif) = new_elseif_decl(ctx, (yyvsp[-3].expression), (yyvsp[0].statement)); }
#line 2185 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 69:
#line 271 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = NULL; }
#line 2191 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 70:
#line 272 "parser.y" /* yacc.c:1648  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 2197 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 71:
#line 275 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = NULL; }
#line 2203 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 72:
#line 276 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = new_case_clausule(ctx, NULL, (yyvsp[0].statement), NULL); }
#line 2209 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 73:
#line 278 "parser.y" /* yacc.c:1648  */
    { (yyval.case_clausule) = new_case_clausule(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), (yyvsp[0].case_clausule)); }
#line 2215 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 74:
#line 281 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL; }
#line 2221 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 75:
#line 282 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 2227 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 76:
#line 285 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = NULL; }
#line 2233 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 77:
#line 286 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2239 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 78:
#line 289 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2245 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 79:
#line 290 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2251 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 80:
#line 291 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOARG, 0); CHECK_ERROR; (yyval.expression)->next = (yyvsp[0].expression); }
#line 2257 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 83:
#line 298 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2263 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 84:
#line 299 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2269 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 85:
#line 302 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2275 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 86:
#line 303 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2281 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 87:
#line 306 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2287 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 88:
#line 307 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2293 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 89:
#line 310 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2299 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 90:
#line 311 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2305 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 91:
#line 314 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2311 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 92:
#line 315 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2317 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 93:
#line 318 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2323 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 94:
#line 319 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2329 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 95:
#line 322 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2335 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 96:
#line 323 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2341 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 97:
#line 326 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2347 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 98:
#line 327 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2353 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 99:
#line 328 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2359 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 100:
#line 329 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2365 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 101:
#line 330 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2371 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 102:
#line 331 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2377 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 103:
#line 332 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2383 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 104:
#line 333 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2389 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 105:
#line 336 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2395 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 106:
#line 337 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2401 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 107:
#line 340 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2407 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 108:
#line 341 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2413 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 109:
#line 342 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2419 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 110:
#line 345 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2425 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 111:
#line 346 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2431 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 112:
#line 349 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2437 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 113:
#line 351 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2443 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 114:
#line 354 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2449 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 115:
#line 356 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2455 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 116:
#line 358 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2461 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 117:
#line 361 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2467 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 118:
#line 362 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2473 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 119:
#line 365 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2479 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 120:
#line 366 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2485 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 121:
#line 367 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_new_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2491 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 122:
#line 368 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2497 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 123:
#line 371 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2503 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 124:
#line 372 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-1].member)->args = (yyvsp[0].expression); (yyval.expression) = &(yyvsp[-1].member)->expr; }
#line 2509 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 125:
#line 375 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; }
#line 2515 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 126:
#line 376 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; }
#line 2521 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 127:
#line 377 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_string_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2527 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 128:
#line 378 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2533 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 129:
#line 379 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; }
#line 2539 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 130:
#line 380 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; }
#line 2545 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 131:
#line 381 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; }
#line 2551 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 132:
#line 384 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, (yyvsp[0].lng)); CHECK_ERROR; }
#line 2557 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 133:
#line 385 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, 0); CHECK_ERROR; }
#line 2563 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 134:
#line 386 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_ULONG, (yyvsp[0].lng)); CHECK_ERROR; }
#line 2569 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 135:
#line 387 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_double_expression(ctx, (yyvsp[0].dbl)); CHECK_ERROR; }
#line 2575 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 136:
#line 390 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].lng); }
#line 2581 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 137:
#line 391 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2587 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 138:
#line 392 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].lng); }
#line 2593 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 139:
#line 395 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_BRACKETS, (yyvsp[-1].expression)); }
#line 2599 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 140:
#line 396 "parser.y" /* yacc.c:1648  */
    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; }
#line 2605 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 141:
#line 399 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-3].class_decl)->name = (yyvsp[-5].string); (yyval.class_decl) = (yyvsp[-3].class_decl); }
#line 2611 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 142:
#line 402 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = new_class_decl(ctx); }
#line 2617 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 143:
#line 403 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2623 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 144:
#line 405 "parser.y" /* yacc.c:1648  */
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[-2].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), dim_decl, (yyvsp[-3].uint)); CHECK_ERROR; }
#line 2630 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 145:
#line 407 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), (yyvsp[-2].dim_decl), 0); CHECK_ERROR; }
#line 2636 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 146:
#line 408 "parser.y" /* yacc.c:1648  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2642 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 147:
#line 412 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_PROPGET, (yyvsp[-8].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2648 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 148:
#line 414 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPLET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2654 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 149:
#line 416 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPSET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2660 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 150:
#line 420 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_SUB, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2666 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 151:
#line 422 "parser.y" /* yacc.c:1648  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_FUNCTION, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2672 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 152:
#line 425 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2678 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 153:
#line 426 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = (yyvsp[0].uint); }
#line 2684 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 154:
#line 429 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = STORAGE_IS_DEFAULT; }
#line 2690 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 155:
#line 430 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = 0; }
#line 2696 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 156:
#line 431 "parser.y" /* yacc.c:1648  */
    { (yyval.uint) = STORAGE_IS_PRIVATE; }
#line 2702 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 157:
#line 434 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = NULL; }
#line 2708 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 158:
#line 435 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = (yyvsp[-1].arg_decl); }
#line 2714 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 159:
#line 438 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = (yyvsp[0].arg_decl); }
#line 2720 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 160:
#line 439 "parser.y" /* yacc.c:1648  */
    { (yyvsp[-2].arg_decl)->next = (yyvsp[0].arg_decl); (yyval.arg_decl) = (yyvsp[-2].arg_decl); }
#line 2726 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 161:
#line 442 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2732 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 162:
#line 443 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2738 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 163:
#line 444 "parser.y" /* yacc.c:1648  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), FALSE); }
#line 2744 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 164:
#line 448 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2750 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 165:
#line 449 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2756 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 166:
#line 450 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2762 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 167:
#line 451 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2768 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 168:
#line 452 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2774 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 169:
#line 453 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2780 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 170:
#line 457 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2786 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 171:
#line 458 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2792 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 172:
#line 459 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2798 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 173:
#line 460 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2804 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 174:
#line 461 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2810 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 175:
#line 462 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2816 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 176:
#line 463 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2822 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 177:
#line 464 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2828 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 178:
#line 465 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2834 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 179:
#line 466 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2840 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 180:
#line 467 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2846 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 181:
#line 468 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2852 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 182:
#line 469 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2858 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 183:
#line 470 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2864 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 184:
#line 471 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2870 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 185:
#line 472 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2876 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 186:
#line 473 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2882 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 187:
#line 474 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2888 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 188:
#line 475 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2894 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 189:
#line 476 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2900 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 190:
#line 477 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2906 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 191:
#line 478 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2912 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 192:
#line 479 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2918 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 193:
#line 480 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2924 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 194:
#line 481 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2930 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 195:
#line 482 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2936 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 196:
#line 483 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2942 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 197:
#line 484 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2948 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 198:
#line 485 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2954 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 199:
#line 486 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2960 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 200:
#line 487 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2966 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 201:
#line 488 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2972 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 202:
#line 489 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2978 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 203:
#line 490 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2984 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 204:
#line 491 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2990 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 205:
#line 492 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2996 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 206:
#line 493 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3002 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 207:
#line 494 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3008 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 208:
#line 495 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3014 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 209:
#line 496 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3020 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 210:
#line 497 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3026 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 211:
#line 498 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3032 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 212:
#line 499 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3038 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 213:
#line 500 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3044 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 214:
#line 501 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3050 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 215:
#line 502 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3056 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 216:
#line 503 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3062 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 217:
#line 504 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3068 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 218:
#line 505 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3074 "parser.tab.c" /* yacc.c:1648  */
    break;

  case 219:
#line 506 "parser.y" /* yacc.c:1648  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3080 "parser.tab.c" /* yacc.c:1648  */
    break;


#line 3084 "parser.tab.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 515 "parser.y" /* yacc.c:1907  */


static int parser_error(parser_ctx_t *ctx, const char *str)
{
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void parse_complete(parser_ctx_t *ctx, BOOL option_explicit)
{
    ctx->parse_complete = TRUE;
    ctx->option_explicit = option_explicit;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    expr->args = NULL;
    return expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, BOOL is_strict, member_expression_t *expr)
{
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->is_strict = is_strict;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL is_array, dim_list_t *dims)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->is_array = is_array;
    decl->dims = dims;
    decl->next = NULL;
    return decl;
}

static dim_list_t *new_dim(parser_ctx_t *ctx, unsigned val, dim_list_t *next)
{
    dim_list_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->val = val;
    ret->next = next;
    return ret;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_select_statement(parser_ctx_t *ctx, expression_t *expr, case_clausule_t *case_clausules)
{
    select_statement_t *stat;

    stat = new_statement(ctx, STAT_SELECT, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->case_clausules = case_clausules;
    return &stat->stat;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, expression_t *expr, statement_t *stat, case_clausule_t *next)
{
    case_clausule_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->stat = stat;
    ret->next = next;
    return ret;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!strcmpiW(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_dim_prop(parser_ctx_t *ctx, class_decl_t *class_decl, dim_decl_t *dim_decl, unsigned storage_flags)
{
    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    dim_decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    dim_decl->next = class_decl->props;
    class_decl->props = dim_decl;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = heap_pool_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code, const WCHAR *delimiter)
{
    static const WCHAR html_delimiterW[] = {'<','/','s','c','r','i','p','t','>',0};

    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + strlenW(ctx->code);

    heap_pool_init(&ctx->heap);

    ctx->parse_complete = FALSE;
    ctx->hres = S_OK;

    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;
    ctx->is_html = delimiter && !strcmpiW(delimiter, html_delimiterW);

    parser_parse(ctx);

    if(FAILED(ctx->hres))
        return ctx->hres;
    if(!ctx->parse_complete) {
        FIXME("parser failed around %s\n", debugstr_w(ctx->code+20 > ctx->ptr ? ctx->code : ctx->ptr-20));
        return E_FAIL;
    }

    return S_OK;
}

void parser_release(parser_ctx_t *ctx)
{
    heap_pool_free(&ctx->heap);
}
